/*  Implementation Module Streng.cp  ******************************* *

	Klassen Streng  (Implementationsmodul)

	TStreng 0.0.1	Terkild Marker	04-09-1995
	TStreng 1.0.0   Terkild Marker 	16-09-1995
	TStreng 1.0.1	Terkild Marker 	16-09-1995
	TStreng 1.0.2	Terkild Marker 	24-09-1995
	TStreng 1.0.3	Terkild Marker 	25-09-1995
	TStreng 1.0.4	Terkild Marker 	26-09-1995
	TStreng 1.0.5	Terkild Marker 	29-09-1995
	TStreng 1.0.6	Terkild Marker 	11-10-1995
	TStreng 1.1.0	Terkild Marker 	16-10-1995
	TStreng 1.1.1	Terkild Marker 	19-10-1995
	TStreng 1.2.0	Terkild Marker	03-11-1995
	TStreng 1.2.1	Terkild Marker	20-01-1996  Tilfjet + og []
	Streng  1.3.0 	Terkild Marker 	29-01-1996  Reorganiseret
	Streng  1.3.1	Terkild Marker	27-02-1996  Tilfjet ==
	Streng  1.3.2	Terkild Marker	13-03-1996  padx og trimx

	Dette er mit klassebiblioteks strengtype og superklassen for alle 
	typer data som jeg vlger at implementere som korte strenge (dvs 
	mindre end 255 tegn).
	Nu vil jeg skrive en strengklasse som kun hviler p TXError, sdan 
	at jeg kan bruge navne nr som helst jeg vil.
	Jeg har besluttet mig til at indbygge TXError i denne her, sdan at 
	jeg kan distribuere min strengklasse separat fra mit klassehieraki.

 * ************************************************************ */


#include "Streng.h"


/*  Constructor for Streng  **************************************** */
Streng::Streng(void)
{
	flag = false;
	krop = nil;
}
/*  END of Constructor  */


/*  Constructor for Streng  **************************************** */
Streng::Streng(const char * const theString)
{
//	IF 4
//	Hvis det lykkes at afstte arealet til den udgende streng,
//	s fortstter vi!    ellers gr vi ikke noget!

//	IF 5
//	Vi undersger om der er nogen fejl rapporteret fra the memory manager;
//	hvis der ikke er dt, s fortstter vi; hvis der er gr vi ingenting!

	unsigned short	antal = theString[0];

	krop = (StringPtr)NewPtrClear(antal + 2);
	if (krop) /* IF 4  */
	{
		error = MemError();
		if (!error) /*  IF 5  */
		{
			unsigned short	indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = theString[indeks];
		}
		//  ELSE 5: next sentence;
		//  END IF 5;
	}
	//  ELSE 4: next sentence;
	//  END IF 4;
}
/*  END of Constructor  */


/*  Constructor for Streng  **************************************** */
Streng::Streng(Str255 theString)
{
	short		antal = theString[0];

	flag = false;
	krop = (StringPtr)NewPtrClear(antal + 2);

	if (krop)
	{
		error = MemError();
		if (!error)
		{
			short		indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = theString[indeks];
		}
	}
}
/*  END of Constructor  */


/*  Constructor for Streng  **************************************** */
Streng::Streng(const Streng & right)
{
//	IF 1
//	Hvis der ikke er noget at hente i den indgende streng, s er
//	der ingen grund til foranstaltninger af nogen art. Jeg skal bare
//	sikre mig at den udgende streng er nulstillet.

//	IF 4
//	Hvis det lykkes at afstte arealet til den udgende streng,
//	s fortstter vi!    ellers gr vi ikke noget!

//	IF 5
//	Vi undersger om der er nogen fejl rapporteret fra the memory manager;
//	hvis der ikke er dt, s fortstter vi; hvis der er gr vi ingenting!

	if (right.flag) /*  IF 1  */
	{
		unsigned short	antal = right.krop[0];

		krop = (StringPtr)NewPtrClear(antal + 2);
		if (krop) /* IF 4  */
		{
			error = MemError();
			if (!error) /*  IF 5  */
			{
				unsigned short	indeks;

				flag = true;
				for (indeks = 0; indeks <= antal; indeks = indeks + 1)
					krop[indeks] = right.krop[indeks];
			}
			//  ELSE 5: next sentence;
			//  END IF 5;
		}
		//  ELSE 4: next sentence;
		//  END IF 4;
	}
	else //  ELSE 1!
	{
		flag = false;
		krop = nil;
	}
	//  END IF 1;

}
/*  END of Constructor  */


/*  Constructor der kopierer strengresource  **************************** */
Streng::Streng(short StringID)
{
	StringHandle	HtoString;
	short			antal;

	flag = false;
	krop = nil;
	HtoString = GetString(StringID);
	antal = (*HtoString)[0];
	krop = (StringPtr)NewPtrClear(antal + 2);

	if (krop)
	{
		error = MemError();
		if (!error)
		{
			short		indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = (*HtoString)[indeks];
		}
	}
}
/*  END of Constructor  */


/*  Constructor der kopierer stringlistresource  ************************** */
Streng::Streng(short StringListID, short StringIndex)
{
	Str255	theString;
	short		antal;

	flag = false;
	krop = nil;
	GetIndString(theString,StringListID,StringIndex);
	antal = theString[0];
	krop = (StringPtr)NewPtrClear(antal + 2);

	if (krop)
	{
		error = MemError();
		if (!error)
		{
			short		indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = theString[indeks];
		}
	}
}
/*  END of Constructor  */


/*  Destructor for Streng  ***************************************** */
Streng::~Streng(void)
{
	if (flag) /*  IF  */
	{
		flag = false;
		DisposePtr((Ptr)krop);
		krop = nil;
	}
	//  ELSE next sentence;
	//  END IF;
}
/*  END of Destructor  */


/*  Function txError  *********************************************  */
OSErr Streng::StrError(void)
{
	return error;
}
/*  END of txError  */


/*  Operator Set  ************************************************** */
Streng& Streng::operator=(const Streng & right)
{
//	IF 1
//	Hvis der ikke er noget at hente i den indgende streng, s er
//	der ingen grund til foranstaltninger af nogen art. Jeg skal bare
//	sikre mig at den udgende streng er nulstillet.

//	IF 2
//	Hvis den udgende streng og den indgende streng er identiske, 
//	skal man ikke give sig til at udradere noget!

//	IF 3
//	Hvis den udgende streng faktisk indeholder noget, skal dette
//	noget udraderes!    ellers skal der ikke gres noget!

//	IF 4
//	Hvis det lykkes at afstte arealet til den udgende streng,
//	s fortstter vi!    ellers gr vi ikke noget!

//	IF 5
//	Vi undersger om der er nogen fejl rapporteret fra the memory manager;
//	hvis der ikke er dt, s fortstter vi; hvis der er gr vi ingenting!

//	IF 13
//	Hvis IF 1 giver falsk skal vi lige sikre os at den udgende streng
//	ikke indeholder noget!

	if (right.flag) /*  if 1  */
	{
		unsigned short	antal = right.krop[0];

		if (this != &right) /*  if 2  */
		{
			if (flag) /*  if 3  */
			{
				flag = false;
				DisposePtr((Ptr)krop);
				krop = nil;
			}
			//  ELSE 3: next sentence;
			//  END IF 3;

			krop = (StringPtr)NewPtrClear(antal + 2);
			if (krop) /* if 4  */
			{
				error = MemError();
				if (!error) /*  IF 5  */
				{
					unsigned short	indeks;

					flag = true;
					for (indeks = 0; indeks <= antal; indeks = indeks + 1)
						krop[indeks] = right.krop[indeks];
				}
				//  ELSE 5: next sentence;
				//  END IF 5;
			}
			//  ELSE 4: next sentence;
			//  END IF 4;
		}
		//  ELSE 2: next sentence;
		//  END IF 2;
	}
	else //  ELSE 1!
	{
		if (flag) /*  if 13  */
		{
			flag = false;
			DisposePtr((Ptr)krop);
			krop = nil;
		}
		//  ELSE 13: next sentence;
		//  END IF 13;
	}
	//  END IF 1;

	return *this;
}
/*  END of Operator  */


/*  Procedure GetStreng    ****************************************** */
void Streng::GetStreng(Str255 &theString)
{
	short		antal = 0;

	if (flag) 
	{
		short		indeks;

		antal = krop[0];
		for (indeks = 0; indeks <= antal; indeks = indeks + 1)
			theString[indeks] = krop[indeks];
	}
	else
	{
		theString[0] = 0;
		theString[1] = 0;
		theString[2] = 0;
		theString[3] = 0;
	}
}
/*  END of GetStreng  */


/*  Procedure GetStreng    ****************************************** */
void Streng::GetStreng(Streng &theString)
{
	theString.SetStreng(krop);
}
/*  END of GetStreng  */


/*  Procedure SetStreng    **************************************** */
void Streng::SetStreng(Str255 theString)
{
	short		antal = theString[0];

	if (flag) 
	{
		flag = false;
		DisposePtr((Ptr)krop);
	}

	krop = (StringPtr)NewPtrClear(antal + 2);

	if (krop)
	{
		error = MemError();
		if (!error)
		{
			short		indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = theString[indeks];
		}
	}
}
/*  END of SetStreng  */


/*  Procedure SetStreng    ****************************************** */
void Streng::SetStreng(Streng theString)
{
	short		antal = theString.krop[0];

	if (flag) 
	{
		flag = false;
		DisposePtr((Ptr)krop);
	}

	krop = (StringPtr)NewPtrClear(antal + 2);

	if (krop)
	{
		error = MemError();
		if (!error)
		{
			short		indeks;

			flag = true;
			for (indeks = 0; indeks <= antal; indeks = indeks + 1)
				krop[indeks] = theString.krop[indeks];
		}
	}
}
/*  END of SetStreng  */


/*  Operator equalp  ************************************************ */
Boolean Streng::operator== (const Streng & RHStrPar)
{
	if (flag) //if #1
		if (RHStrPar.flag) //if #4
			if (krop) //if #6
				if (RHStrPar.krop) //if #8
					if (krop == RHStrPar.krop) //if #9
						return true;
					else //else #9
					{
						short lngdLV = krop[0];
						short lngdRH = RHStrPar.krop[0];
						if (lngdLV == lngdRH) //if #10
						{
							short indeks = 0;
							short max = lngdLV;
							Boolean Fanget = false;
							while ((!Fanget) || (indeks <= max))
							{
								Fanget = (krop[indeks] == RHStrPar.krop[indeks]);
								//	burde jeg mske sprge om det sidste tegn var
								//	ascii(0)?  Jeg kunne hvde at strengen sluttede
								//	nr jeg nede et ascii(0)!
							}
							return !Fanget;
						}
						else //else #10
							return false;
						//end if #10
					}
					//end if #9
				else //else #8
					return false;
				//end if #8
			else //else #6
				if (RHStrPar.krop) //if #7
					return false;
				else //else #7
					return true;
				//end if #7
			//end #6
		else //else #4
			if (RHStrPar.krop) //if #5
				return false;
			else //else #5
				return true;
			//end if #5
		//end if #4
	else //else #1
		if (RHStrPar.flag) //if #2
			if (RHStrPar.krop) //if #3
				return false;
			else //else #3
				return true;
			//end if #3
		else //else #2
			return true;
		//end if #2
	//end if #1
}
/*  END of Operator  */


/*  Operator add  ************************************************ */
Streng Streng::operator+(const Streng & right)
{
	Streng			temp;
	short			LengthOfResult = 0;
	short			LengthOfLeft = 0;
	short			LengthOfRight = 0;
	unsigned short	indeks = 0;
	unsigned short	index2 = 0;

	if (krop)
		LengthOfLeft = krop[0];
	else
		LengthOfLeft = 0;

	if (right.krop)
		LengthOfRight = right.krop[0];
	else
		LengthOfRight = 0;

	LengthOfResult = LengthOfLeft + LengthOfRight;
	
	if (LengthOfResult < 0) 
	{
		LengthOfResult = 0;
		return temp;
	}

	if (LengthOfResult > 254) LengthOfResult = 254;
	temp.krop = (StringPtr)NewPtrClear(LengthOfResult + 2);
	if (!temp.krop) return temp;
	temp.flag = true;

//	copy left to result!
	{
		unsigned short	usx;

		for (usx = 1; usx <= LengthOfLeft; usx = usx + 1)
		{
			temp.krop[usx] = krop[usx];
		}
	}

//	copy str2 to result!
	{
		unsigned short usx;
		unsigned short usy;

		for (usx = LengthOfLeft+1, usy = 1; 
				usx <= LengthOfResult; 
				usx = usx + 1, usy = usy + 1)
		{
			temp.krop[usx] = right.krop[usy];
		}
	}
	temp.krop[0] = LengthOfResult;

	return temp;	//	return new string!
}
/*  END of Operator  */


/*  Operator add  ************************************************ */
Streng Streng::operator+(const char & right)
{
	Streng			temp;
	short			LengthOfResult = 0;
	short			LengthOfLeft = 0;
	short			LengthOfRight = 1;	//	right er enkelt tegn!
	unsigned short	indeks = 0;
	unsigned short	index2 = 0;

	if (krop)
		LengthOfLeft = krop[0];
	else
		LengthOfLeft = 0;

	//	LengthOfRight = 1;

	//	LengthOfResult = LengthOfLeft + LengthOfRight;
	LengthOfResult = LengthOfLeft + 1;
	
	if (LengthOfResult < 0) 
	{
		LengthOfResult = 0;
		return temp;
	}

	if (LengthOfResult > 254) LengthOfResult = 254;
	temp.krop = (StringPtr)NewPtrClear(LengthOfResult + 2);
	if (!temp.krop) return temp;
	temp.flag = true;

//	copy left to result!
	{
		unsigned short	usx;

		for (usx = 1; usx <= LengthOfLeft; usx = usx + 1)
		{
			temp.krop[usx] = krop[usx];
		}
	}

//	copy char to result!
	temp.krop[LengthOfLeft+1] = right;
	temp.krop[0] = LengthOfResult;

	return temp;	//	return new string!
}
/*  END of Operator  */


/*  Operator []  *************************************************** */
char & Streng::operator[](unsigned short offset)
{
	unsigned char	xsLength;
	if (flag)
	{
		xsLength = krop[0];
		if (xsLength > 254) return krop[255];
		
		if (offset > xsLength)
		{
			StringPtr	temp = krop;

			krop = (StringPtr)NewPtrClear(xsLength + 3);
			if (krop)
			{
				error = MemError();
				if (!error)
				{
					unsigned short	indeks;
		
					flag = true;
					for (indeks = 0; indeks <= xsLength; indeks = indeks + 1)
						krop[indeks] = temp[indeks];
					krop[0] = xsLength + 1;
					krop[xsLength+1] = '\040';
				}
				DisposePtr((Ptr)temp);
			}

			return krop[xsLength + 1];
		}
		else
			return krop[offset];
	}
	else
	{
		xsLength = 1;

		krop = (StringPtr)NewPtrClear(3);
		if (krop)
		{
			error = MemError();
			if (!error) 
			{
				krop[0] = '\001';
				krop[1] = '\040';
			}
		}
		return krop[1];
	}
}
/*  END of Operator  */


/*  Operator []  *************************************************** */
char Streng::operator[](unsigned short offset) const
{
	unsigned char	xsLength = krop[0];
	
	if (offset > xsLength)
		return krop[xsLength + 1];
	else
		return krop[offset];
}
/*  END of Operator  */


/*  Procedure GetNumber  ******************************************** *

	Procedure SetTStreng	Terkild Marker 	29-09-1995  
	Procedure GetNumber		Terkild Marker	29-01-1996

	Denne procedure sletter indholdet af en Streng, konverterer en 
	short til en streng af cifre og stter det nye indhold af 
	Strengen til denne streng af cifre.

 *  ************************************************************** */
void Streng::GetNumber(short tal)
{
	if (flag) 
	{
		DisposePtr((Ptr)krop);
		flag = false;
	}

	krop = (StringPtr)NewPtrClear(9);
	error = MemError();
	if (!error) 
	{
		flag = true;
		NumToString(tal,krop);
	}
}
/*  END of GetNumber  */


/*  Procedure GetNumber  ******************************************** *

	Procedure SetTStreng  	Terkild Marker 	29-09-1995  
	Procedure GetNumber		Terkild Marker	29-01-1996

	Denne procedure sletter indholdet af en Streng, konverterer en 
	long til en streng af cifre og stter det nye indhold af 
	Strengen til denne streng af cifre.

 *  ************************************************************** */
void Streng::GetNumber(long tal)
{
	if (flag) 
	{
		DisposePtr((Ptr)krop);
		flag = false;
	}

	krop = (StringPtr)NewPtrClear(15);
	error = MemError();
	if (!error) 
	{
		flag = true;
		NumToString(tal,krop);
	}
}
/*  END of GetNumber  */


/*  Procedure trim  ************************************************ */
void Streng::trim(void)
{
	trimL();
	trimR();
}
//  END trim;


/*  Procedure trimL  *********************************************** */
void Streng::trimL(void)
{
	unsigned short max = krop[0];
	unsigned short indeks = 1;
	char tegn = krop[1];

	while (tegn < '!')
	{
		indeks = indeks + 1;
		max = max - 1;
		tegn = krop[indeks];
	}

	short pull = indeks - 1;

	while (tegn > 0)
	{
		krop[indeks - pull] = krop[indeks];
		indeks = indeks + 1;
		tegn = krop[indeks];
	}

	krop [indeks - pull] = 0;

	indeks = 1;
	tegn = krop[1];
	while (tegn > 0)
	{
		indeks = indeks + 1;
		tegn = krop[indeks];
		if (indeks > max) tegn = 0;
	}

	krop[0] = indeks - 1;
}
//  END trimL;


/*  Procedure trimR  *********************************************** */
void Streng::trimR(void)
{
	Boolean	FlagR = false;
	char		tegn = ' ';
	short		indeks = 0;

	while (!FlagR) 
	{
		indeks = krop[0];
		tegn = krop[indeks];
		if (tegn < '!')
		{
			krop[indeks] = 0;
			indeks = indeks - 1;
			krop[0] = indeks;
		}
		else
		{
			FlagR = true;
		}
	}
}
//  END trimR;


/*  Procedure padC  ********************************************** */
void Streng::padC(short total, char tegn)
{
	short OddManOut = total % 2;
	short HalfWayThere = (total - (krop[0]))/2;

	padL(HalfWayThere + OddManOut + (krop[0]),tegn);
	padR(total,tegn);
}
//  END padC;


/*  Procedure padR  ********************************************** */
void Streng::padR(short total, char tegn)
{
//	IF 1
//	Hvis der ikke er noget at hente i den indgende streng, s er der ingen 
//	grund til foranstaltninger af nogen art. Jeg skal bare fylde den udgende 
//	streng ud med et passende antal af tegn.

//	IF 4
//	Hvis det lykkes at afstte arealet til den udgende streng,
//	s fortstter vi!    ellers gr vi ikke noget!

//	IF 5
//	Vi undersger om der er nogen fejl rapporteret fra the memory manager;
//	hvis der ikke er dt, s fortstter vi; hvis der er gr vi ingenting!

	if (flag) /*  IF 1  */
	{
		unsigned short max = krop[0];
		if (max >= total)
			return;
		else
		{
			StringPtr temp = krop;
			krop = (StringPtr)NewPtrClear(total + 2);
			if (krop) /* IF 4  */
			{
				error = MemError();
				if (!error) /*  IF 5  */
				{
					unsigned short	indeks;

					flag = true;
					for (indeks = 1; indeks <= total; indeks = indeks + 1)
						krop[indeks] = tegn;
					krop[0] = total;

					for (indeks = 1; indeks <= max; indeks = indeks + 1)
						krop[indeks] = temp[indeks];
					DisposePtr((Ptr)temp);
				}
				//  ELSE 5: next sentence;
				//  END IF 5;
			}
			//  ELSE 4: next sentence;
			//  END IF 4;
		}
	}
	else //  ELSE 1!
	{
		krop = (StringPtr)NewPtrClear(total + 2);
		if (krop) /* IF 4  */
		{
			error = MemError();
			if (!error) /*  IF 5  */
			{
				unsigned short	indeks;

				flag = true;
				for (indeks = 0; indeks <= total; indeks = indeks + 1)
					krop[indeks] = tegn;
			}
			//  ELSE 5: next sentence;
			//  END IF 5;
		}
		//  ELSE 4: next sentence;
		//  END IF 4;
	}
	//  END IF 1;
}
//  END padR;


/*  Procedure padL  ********************************************** */
void Streng::padL(short total, char tegn)
{
//	IF 1
//	Hvis der ikke er noget at hente i den indgende streng, s er der ingen 
//	grund til foranstaltninger af nogen art. Jeg skal bare fylde den udgende 
//	streng ud med et passende antal af tegn.

//	IF 4
//	Hvis det lykkes at afstte arealet til den udgende streng,
//	s fortstter vi!    ellers gr vi ikke noget!

//	IF 5
//	Vi undersger om der er nogen fejl rapporteret fra the memory manager;
//	hvis der ikke er dt, s fortstter vi; hvis der er gr vi ingenting!

	if (flag) /*  IF 1  */
	{
		unsigned short max = krop[0];
		if (max >= total)
			return;
		else
		{
			StringPtr temp = krop;
			krop = (StringPtr)NewPtrClear(total + 2);
			if (krop) /* IF 4  */
			{
				error = MemError();
				if (!error) /*  IF 5  */
				{
					unsigned short	indeks;

					flag = true;
					for (indeks = 1; indeks <= total; indeks = indeks + 1)
						krop[indeks] = tegn;
					krop[0] = total;

					for (indeks = 1; indeks <= max; indeks = indeks + 1)
						krop[indeks+total-max] = temp[indeks];
					DisposePtr((Ptr)temp);
				}
				//  ELSE 5: next sentence;
				//  END IF 5;
			}
			//  ELSE 4: next sentence;
			//  END IF 4;
		}
	}
	else //  ELSE 1!
	{
		krop = (StringPtr)NewPtrClear(total + 2);
		if (krop) /* IF 4  */
		{
			error = MemError();
			if (!error) /*  IF 5  */
			{
				unsigned short	indeks;

				flag = true;
				for (indeks = 0; indeks <= total; indeks = indeks + 1)
					krop[indeks] = tegn;
			}
			//  ELSE 5: next sentence;
			//  END IF 5;
		}
		//  ELSE 4: next sentence;
		//  END IF 4;
	}
	//  END IF 1;
}
//  END padL;


/*  END of Streng.cp  */



